## python2.7 2.7.16.5

=== debian/changelog ===
python2.7 (2.7.16.5-1+dde) unstable; urgency=medium

  * fix CVE-2019-20907 and CVE-2020-8492

 -- Ding Heng <dingheng@uniontech.com>  Sun, 09 Oct 2022 16:54:49 +0800

python2.7 (2.7.16.4-1+dde) unstable; urgency=medium

  * add loongarch64 support

 -- Angie.J <doucaixia@uniontech.com>  Thu, 30 Sep 2021 10:54:14 +0800

python2.7 (2.7.16.3-1+dde) unstable; urgency=medium

  * uos sw64 porting

 -- deepin/sw64 team <sunway@deepin.com>  Tue, 23 Feb 2021 13:35:05 +0800

=== debian/control ===
Source: python2.7
Section: python
Priority: optional
Maintainer: Matthias Klose <doko@debian.org>
Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.17.11), 
  quilt, autoconf, autotools-dev,
  lsb-release, sharutils,
  libreadline-dev, libtinfo-dev, libncursesw5-dev (>= 5.3),
  tk-dev, blt-dev (>= 2.4z), libssl-dev (>= 1.1.1),
  zlib1g-dev, libbz2-dev,
  libexpat1-dev,
  libbluetooth-dev [linux-any] <!profile.nobluetooth>,
  locales [!armel !avr32 !hppa !ia64 !mipsel],
  libsqlite3-dev, libffi-dev (>= 3.0.5) [!or1k !avr32],
  libgpm2 [linux-any],
  mime-support, netbase, net-tools, bzip2, time,
  libdb-dev (<< 1:6.0), libgdbm-dev, python:any, help2man,
  xvfb, xauth
Build-Depends-Indep: python3-sphinx
Build-Conflicts: tcl8.4-dev, tk8.4-dev,
  python2.7-xml, python-xml,
  autoconf2.13, python-cxx-dev,
  hardening-wrapper
Standards-Version: 4.3.0
Vcs-Browser: https://salsa.debian.org/cpython-team/python2
Vcs-Git: https://salsa.debian.org/cpython-team/python2.git
XS-Testsuite: autopkgtest

Package: python2.7
Architecture: any
Multi-Arch: allowed
Priority: optional
Depends: python2.7-minimal (= ${binary:Version}), libpython2.7-stdlib (= ${binary:Version}), mime-support, ${shlibs:Depends}, ${misc:Depends}
Suggests: python2.7-doc, binutils
Conflicts: python-profiler (<= 2.7.1-2)
Breaks: python-virtualenv (<< 1.7.1.2-2~), vim-nox (<< 2:7.3.547-4), vim-gtk (<< 2:7.3.547-4), vim-gnome (<< 2:7.3.547-4), vim-athena (<< 2:7.3.547-4)
Replaces: python-profiler (<= 2.7.1-2), python2.7-minimal (<< 2.7.3-7~)
Description: Interactive high-level object-oriented language (version 2.7)
 Python is a high-level, interactive, object-oriented language. Its 2.7 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.

Package: libpython2.7-stdlib
Architecture: any
Multi-Arch: same
Priority: optional
Depends: libpython2.7-minimal (= ${binary:Version}), libssl1.1 (>= 1.1.1), mime-support, ${shlibs:Depends}, ${misc:Depends}
Provides: python2.7-cjkcodecs, python2.7-ctypes, python2.7-elementtree, python2.7-celementtree, python2.7-wsgiref, python2.7-profiler, python2.7-argparse, python-argparse
Replaces: python2.7 (<< 2.7.5-0~), libpython2.7-testsuite (<< 2.7.13-4)
Breaks: python-urllib3 (<< 1.9.1-3), ${pyfpe:Breaks}
Description: Interactive high-level object-oriented language (standard library, version 2.7)
 Python is a high-level, interactive, object-oriented language. Its 2.7 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package contains Python 2.7's standard library. It is normally not
 used on its own, but as a dependency of python2.7.

Package: python2.7-minimal
Architecture: any
Multi-Arch: allowed
Priority: optional
Pre-Depends: ${shlibs:Pre-Depends}
Depends: libpython2.7-minimal (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Recommends: python2.7
Suggests: binfmt-support
Replaces: python2.7 (<< 2.7.8-7~)
Conflicts: binfmt-support (<< 1.1.2)
Description: Minimal subset of the Python language (version 2.7)
 This package contains the interpreter and some essential modules.  It can
 be used in the boot process for some basic tasks.
 See /usr/share/doc/python2.7-minimal/README.Debian for a list of the modules
 contained in this package.

Package: libpython2.7-minimal
Architecture: any
Multi-Arch: same
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libpython2.7-stdlib
Replaces: python2.7 (<< 2.7.4-2), python2.7-minimal (<< 2.7.3-10), libpython2.7-stdlib (<< 2.7.8-7)
Breaks: python2.7-minimal (<< 2.7.4~rc1-1~)
Conflicts: binfmt-support (<< 1.1.2)
Description: Minimal subset of the Python language (version 2.7)
 This package contains some essential modules. It is normally not
 used on it's own, but as a dependency of python2.7-minimal.

Package: libpython2.7
Architecture: any
Multi-Arch: same
Section: libs
Priority: optional
Pre-Depends: ${misc:Pre-Depends} 
Depends: libpython2.7-stdlib (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Replaces: python2.7 (<< 2.6)
Description: Shared Python runtime library (version 2.7)
 Python is a high-level, interactive, object-oriented language. Its 2.7 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package contains the shared runtime library, normally not needed
 for programs using the statically linked interpreter.

Package: python2.7-examples
Architecture: all
Multi-Arch: foreign
Depends: python2.7:any (>= ${source:Version}), ${misc:Depends}
Description: Examples for the Python language (v2.7)
 Examples, Demos and Tools for Python (v2.7). These are files included in
 the upstream Python distribution (v2.7).

Package: python2.7-dev
Architecture: any
Multi-Arch: allowed
Depends: python2.7 (= ${binary:Version}), libpython2.7-dev (= ${binary:Version}), libpython2.7 (= ${binary:Version}), libexpat1-dev, ${shlibs:Depends}, ${misc:Depends}
Recommends: libc6-dev | libc-dev
Replaces: python2.7 (<< 2.7-3)
Description: Header files and a static library for Python (v2.7)
 Header files, a static library and development tools for building
 Python (v2.7) modules, extending the Python interpreter or embedding
 Python (v2.7) in applications.
 .
 Maintainers of Python packages should read README.maintainers.

Package: libpython2.7-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends} 
Depends: libpython2.7-stdlib (= ${binary:Version}), libpython2.7 (= ${binary:Version}), libexpat1-dev, ${shlibs:Depends}, ${misc:Depends}
Replaces: python2.7 (<< 2.7-3), python2.7-dev (<< 2.7.3-10), python2.7-minimal (<< 2.7.3-10)
Recommends: libc6-dev | libc-dev
Description: Header files and a static library for Python (v2.7)
 Header files, a static library and development tools for building
 Python (v2.7) modules, extending the Python interpreter or embedding
 Python (v2.7) in applications.
 .
 Maintainers of Python packages should read README.maintainers.
 .
 This package contains development files. It is normally not
 used on it's own, but as a dependency of python2.7-dev.

Package: libpython2.7-testsuite
Section: libdevel
Architecture: all
Depends: libpython2.7-stdlib (>= ${binary:Version}), ${misc:Depends}
Suggests: python-gdbm, python-tk
Description: Testsuite for the Python standard library (v2.7)
 The complete testsuite for the Python standard library.  Note that
 a subset is found in the libpython2.7-stdlib package, which should
 be enough for other packages to use (please do not build-depend
 on this package, but file a bug report to include additional 
 testsuite files in the libpython2.7-stdlib package).

Package: idle-python2.7
Architecture: all
Depends: python2.7, python-tk (>= 2.6~a3), python2.7-tk, ${misc:Depends}
Enhances: python2.7
Replaces: python2.7 (<< 2.6.1-2)
Description: IDE for Python (v2.7) using Tkinter
 IDLE is an Integrated Development Environment for Python (v2.7).
 IDLE is written using Tkinter and therefore quite platform-independent.

Package: python2.7-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: libjs-jquery, libjs-underscore, ${misc:Depends}
Suggests: python2.7
Description: Documentation for the high-level object-oriented language Python (v2.7)
 These is the official set of documentation for the interactive high-level
 object-oriented language Python (v2.7). All documents are provided
 in HTML format. The package consists of ten documents:
 .
   * What's New in Python2.7
   * Tutorial
   * Python Library Reference
   * Macintosh Module Reference
   * Python Language Reference
   * Extending and Embedding Python
   * Python/C API Reference
   * Installing Python Modules
   * Documenting Python
   * Distributing Python Modules

Package: python2.7-dbg
Section: debug
Architecture: any
Multi-Arch: allowed
Depends: python2.7 (= ${binary:Version}), libpython2.7-dbg (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Suggests: python-gdbm-dbg, python-tk-dbg
Description: Debug Build of the Python Interpreter (version 2.7)
 The package holds two things:
 .
 - A Python interpreter configured with --pydebug. Dynamically loaded modules
   are searched as <foo>_d.so first. Third party extensions need a separate
   build to be used by this interpreter.
 - Debug information for standard python interpreter and extensions.
 .
 See the README.debug for more information.

Package: libpython2.7-dbg
Section: debug
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends} 
Depends: libpython2.7-stdlib (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Suggests: python2.7-gdbm-dbg, python2.7-tk-dbg
Replaces: python2.7-dbg (<< 2.7.3-10)
Description: Debug Build of the Python Interpreter (version 2.7)
 The package holds two things:
 .
 - Extensions for a Python interpreter configured with --pydebug.
 - Debug information for standard python extensions.
 .
 See the README.debug for more information.

=== debian/rules ===
#!/usr/bin/make -f

unexport LANG LC_ALL LC_CTYPE LC_COLLATE LC_TIME LC_NUMERIC LC_MESSAGES
unexport CFLAGS CXXFLAGS CPPFLAGS LDFLAGS

export SHELL = /bin/bash

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

vafilt = $(subst $(2)=,,$(filter $(2)=%,$(1)))

DPKG_VARS		:= $(shell dpkg-architecture)
DEB_BUILD_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_ARCH)
DEB_BUILD_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_GNU_TYPE)
DEB_HOST_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH)
DEB_HOST_ARCH_BITS	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH_BITS)
DEB_HOST_ARCH_ENDIAN	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH_ENDIAN)
DEB_HOST_ARCH_OS	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH_OS)
DEB_HOST_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_GNU_TYPE)
DEB_HOST_MULTIARCH	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_MULTIARCH)

changelog_values := $(shell dpkg-parsechangelog \
			| awk '/^(Version|Source):/ {print $$2}')
PKGSOURCE  := $(word 1, $(changelog_values))
PKGVERSION := $(word 2, $(changelog_values))

LAST_CHANGE := $(shell dpkg-parsechangelog -S Date)
export BUILD_DATE := $(shell LC_ALL=C date -u +'%b %e %Y' -d '$(LAST_CHANGE)')
export BUILD_TIME := $(shell LC_ALL=C date -u +'%H:%M:%S' -d '$(LAST_CHANGE)')

SPHINXOPTS := -D today='$(shell LC_ALL=C date -u +'%B %d, %Y' -d '$(LAST_CHANGE)')'
SPHINXOPTS += -D html_last_updated_fmt='$(shell LC_ALL=C date -u +'%B %d, %Y' -d '$(LAST_CHANGE)')'
export SPHINXOPTS

on_buildd := $(shell [ -f /CurrentlyBuilding -o "$$LOGNAME" = buildd -o "$$USER" = buildd ] && echo yes)

dh_compat2 := $(shell dpkg --compare-versions "$$(dpkg-query -f '$${Version}' -W debhelper)" lt 9.20150811ubuntu2 && echo DH_COMPAT=2)

ifneq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
  WITHOUT_CHECK := yes
endif
WITHOUT_BENCH :=
ifneq (,$(findstring nobench, $(DEB_BUILD_OPTIONS)))
  WITHOUT_BENCH := yes
endif
ifneq (,$(filter $(DEB_HOST_ARCH), hurd-i386))
  WITHOUT_BENCH := disabled on $(DEB_HOST_ARCH)
endif
ifeq ($(on_buildd),yes)
  ifneq (,$(findstring $(DEB_HOST_ARCH), hppa loongarch64 mips mipsel mipsn32 mipsn32el mips64 mips64el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64r6 mips64r6el s390))
    WITHOUT_CHECK := yes
  endif
endif
ifneq (,$(filter $(DEB_HOST_ARCH), hurd-i386 kfreebsd-amd64 kfreebsd-i386))
  WITHOUT_CHECK := yes
endif
ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
  WITHOUT_BENCH := yes
  WITHOUT_CHECK := yes
endif

COMMA = ,
ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
  NJOBS := -j $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
endif

distribution := $(shell lsb_release -is)
distrelease  := $(shell lsb_release -cs)
derivative := $(shell if dpkg-vendor --derives-from Ubuntu; then echo Ubuntu; \
               elif dpkg-vendor --derives-from Debian; then echo Debian; \
               else echo Unknown; fi)

VER=2.7
NVER=2.8
PVER=python2.7
PRIORITY=$(shell echo $(VER) | tr -d '.')0

PREVVER	:= $(shell awk '/^python/ && NR > 1 {print substr($$2,2,length($$2)-2); exit}' debian/changelog)

# default versions are built from the python-defaults source package
# keep the definition to adjust package priorities.
DEFAULT_VERSION = yes
STATIC_PYTHON=yes

MIN_MODS := $(shell awk '/^  / && $$2 == "module" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_EXTS := $(shell awk '/^  / && $$2 ~ /^extension/ { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_BUILTINS := $(shell awk '/^  / && $$2 == "builtin" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_PACKAGES := $(shell awk '/^  / && $$2 == "package" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_ENCODINGS := $(foreach i, \
			$(filter-out \
			  big5% bz2% cp932.py cp949.py cp950.py euc_% \
			  gb% iso2022% johab.py shift_jis% , \
			  $(shell cd Lib/encodings && echo *.py)), \
			encodings/$(i)) \
		 codecs.py stringprep.py

with_tk := no
with_gdbm := no
with_interp := static
#with_interp := shared

PY_INTERPRETER = /usr/bin/python$(VER)

ifeq ($(DEFAULT_VERSION),yes)
  ifneq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid precise trusty xenial yakkety))
    PY_PRIO = standard
  else
    PY_PRIO = optional
  endif
  #PYSTDDEP = , python (>= $(VER))
  PY_MINPRIO = $(PY_PRIO)
else
  PY_PRIO = optional
  PY_MINPRIO = $(PY_PRIO)
endif
ifneq (,$(filter $(distrelease),stretch lenny squeeze wheezy precise xenial yakkety zesty))
  with_fpectl = yes
endif

ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric))
  bd_qual = :any
endif
ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric))
  ma_filter = cat
else
  ma_filter = grep -v '^Multi-Arch:'
endif
ifneq (,$(filter $(distrelease),jessie experimental))
  bd_gcc =
endif
ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric precise quantal raring saucy trusty))
  bd_dpkgdev = dpkg-dev (>= 1.17.11),
endif
ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric precise quantal raring saucy trusty utopic vivid wily xenial))
  pf_bluetooth = $(EMPTY) <!profile.nobluetooth>
endif

CC = $(DEB_HOST_GNU_TYPE)-gcc
CXX=$(DEB_HOST_GNU_TYPE)-g++

AR=$(DEB_HOST_GNU_TYPE)-ar
RANLIB=$(DEB_HOST_GNU_TYPE)-ranlib

DPKG_CFLAGS  := $(shell dpkg-buildflags --get CPPFLAGS; dpkg-buildflags --get CFLAGS)
DPKG_CFLAGS  := $(subst -fstack-protector-strong,-fstack-protector,$(DPKG_CFLAGS))
DPKG_LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)
OPT_CFLAGS   := $(filter-out -O%,$(DPKG_CFLAGS)) # default is -O3
DEBUG_CFLAGS := $(filter-out -D_FORTIFY_SOURCE=%,$(patsubst -O%,-O0,$(DPKG_CFLAGS)))

# on alpha, use -O2 only, use -mieee
ifeq ($(DEB_HOST_ARCH),alpha)
    OPT_CFLAGS += -mieee
    DEBUG_CFLAGS += -mieee
    EXTRA_OPT_FLAGS += -O2
endif
# on sw_64, use -O0
ifeq ($(DEB_HOST_ARCH),sw_64)
    OPT_CFLAGS += -O0
endif
# issues with ia64 and m68k with -O3
ifeq ($(DEB_HOST_ARCH),m68k)
    EXTRA_OPT_FLAGS += -O2
endif

ifneq (,$(filter $(DEB_HOST_ARCH), ppc64 ppc64el))
    OPT_CFLAGS += -fexceptions
    DEBUG_CFLAGS += -fexceptions
endif

ifeq ($(DEB_HOST_ARCH_OS),linux)
  ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 armel armhf i386 powerpc ppc64 ppc64el s390x x32 sw_64))
    with_pgo := yes
  endif
endif
ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
  with_pgo :=
endif

ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 armel armhf i386 powerpc ppc64 ppc64el s390x x32 sw_64))
  with_lto := yes
endif

ifeq ($(with_lto),yes)
    LTO_CFLAGS = -g -flto -fuse-linker-plugin
    with_fat_lto := $(shell dpkg --compare-versions $$($(CC) --version \
			| sed -n '/^$(CC)/s/.* //p') ge 4.9 && echo yes)
    ifeq ($(with_fat_lto),yes)
      LTO_CFLAGS += -ffat-lto-objects
    endif
    EXTRA_OPT_CFLAGS += $(LTO_CFLAGS)
    AR=$(DEB_HOST_GNU_TYPE)-gcc-ar
    RANLIB=$(DEB_HOST_GNU_TYPE)-gcc-ranlib
endif

ifneq ($(with_fpectl),yes)
  ifeq ($(derivative),Ubuntu)
    arch_substvars =  '-Vpyfpe:Breaks=$(shell tr '\n' ' ' < debian/pyfpe-breaks.$(derivative))'
  else ifeq ($(derivative),Debian)
    arch_substvars =  '-Vpyfpe:Breaks=$(shell tr '\n' ' ' < debian/pyfpe-breaks.$(derivative))'
  endif
endif

make_build_target = $(if $(with_pgo),profile-opt)

buildd_static	:= $(CURDIR)/build-static
buildd_shared	:= $(CURDIR)/build-shared
buildd_debug	:= $(CURDIR)/build-debug
buildd_shdebug	:= $(CURDIR)/build-shdebug

d		:= debian/tmp
scriptdir	=  usr/share/lib/python$(VER)
scriptdir	=  usr/share/python$(VER)
scriptdir	=  usr/lib/python$(VER)

# package names and directories
p_base	:= $(PVER)
p_min	:= $(PVER)-minimal
p_lib	:= lib$(PVER)
p_tk	:= $(PVER)-tk
p_gdbm	:= $(PVER)-gdbm
p_dev	:= $(PVER)-dev
p_exam	:= $(PVER)-examples
p_idle	:= idle-$(PVER)
p_doc	:= $(PVER)-doc
p_dbg	:= $(PVER)-dbg

p_lbase	:= lib$(PVER)-stdlib
p_lmin	:= lib$(PVER)-minimal
p_ldev	:= lib$(PVER)-dev
p_ldbg	:= lib$(PVER)-dbg
p_ltst	:= lib$(PVER)-testsuite

d_base	:= debian/$(p_base)
d_min	:= debian/$(p_min)
d_lib	:= debian/$(p_lib)

=== debian/tests/control ===
Tests: testsuite
Depends: build-essential, locales, python2.7-dev, libpython2.7-testsuite, python-gdbm
# test_zipfile wants to write
Restrictions: needs-root

Tests: testsuite-dbg
Depends: build-essential, locales, python2.7-dev, python2.7-dbg, libpython2.7-testsuite, python-gdbm-dbg
# test_zipfile wants to write
Restrictions: needs-root

Tests: failing-tests
Depends: build-essential, locales, python2.7-dev, libpython2.7-testsuite, python-gdbm
# test_zipfile wants to write
Restrictions: needs-root allow-stderr

Tests: failing-tests-dbg
Depends: build-essential, locales, python2.7-dev, python2.7-dbg, libpython2.7-testsuite, python-gdbm-dbg
# test_zipfile wants to write
Restrictions: needs-root allow-stderr

=== debian/watch ===
version=3
opts=dversionmangle=s/.*\+//,uversionmangle=s/([abcr]+[1-9])$/~$1/ \
  http://www.python.org/ftp/python/(2\.7\.\d*)/Python-(2\.7[.\dabcr]*)\.tgz

## python2.7 2.7.18

=== Doc/Makefile ===
#
# Makefile for Python documentation
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#

# You can set these variables from the command line.
PYTHON       = python
VENVDIR      = ./venv
SPHINXBUILD  = PATH=$(VENVDIR)/bin:$$PATH sphinx-build
BLURB        = PATH=$(VENVDIR)/bin:$$PATH blurb
PAPER        =
SOURCES      =
DISTVERSION  = $(shell $(PYTHON) tools/extensions/patchlevel.py)

ALLSPHINXOPTS = -b $(BUILDER) -d build/doctrees -D latex_elements.papersize=$(PAPER) \
                $(SPHINXOPTS) . build/$(BUILDER) $(SOURCES)

.PHONY: help build html htmlhelp latex text changes linkcheck \
	suspicious coverage doctest pydoc-topics htmlview clean dist check serve \
	autobuild-dev autobuild-stable

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  clean      to remove build files"
	@echo "  html       to make standalone HTML files"
	@echo "  htmlview   to open the index page built by the html target in your browser"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  text       to make plain text files"
	@echo "  epub       to make EPUB files"
	@echo "  changes    to make an overview over all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  coverage   to check documentation coverage for library and C API"
	@echo "  doctest    to run doctests in the documentation"
	@echo "  pydoc-topics  to regenerate the pydoc topics file"
	@echo "  dist       to create a \"dist\" directory with archived docs for download"
	@echo "  suspicious to check for suspicious markup in output text"
	@echo "  check      to run a check for frequent markup errors"
	@echo "  serve      to serve the documentation on the localhost (8000)"

build:
	$(SPHINXBUILD) $(ALLSPHINXOPTS)
	@echo

html: BUILDER = html
html: build
	@echo "Build finished. The HTML pages are in build/html."

htmlhelp: BUILDER = htmlhelp
htmlhelp: build
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      "build/htmlhelp/pydoc.hhp project file."

latex: BUILDER = latex
latex: build
	@echo "Build finished; the LaTeX files are in build/latex."
	@echo "Run \`make all-pdf' or \`make all-ps' in that directory to" \
	      "run these through (pdf)latex."

text: BUILDER = text
text: build
	@echo "Build finished; the text files are in build/text."

epub: BUILDER = epub
epub: build
	@echo "Build finished; the epub files are in build/epub."

changes: BUILDER = changes
changes: build
	@echo "The overview file is in build/changes."

linkcheck: BUILDER = linkcheck
linkcheck:
	@$(MAKE) build BUILDER=$(BUILDER) || { \
	echo "Link check complete; look for any errors in the above output" \
	     "or in build/$(BUILDER)/output.txt"; \
	false; }

suspicious: BUILDER = suspicious
suspicious:
	@$(MAKE) build BUILDER=$(BUILDER) || { \
	echo "Suspicious check complete; look for any errors in the above output" \
	     "or in build/$(BUILDER)/suspicious.csv.  If all issues are false" \
	     "positives, append that file to tools/susp-ignored.csv."; \
	false; }

coverage: BUILDER = coverage
coverage: build
	@echo "Coverage finished; see c.txt and python.txt in build/coverage"

doctest: BUILDER = doctest
doctest:
	@$(MAKE) build BUILDER=$(BUILDER) || { \
	echo "Testing of doctests in the sources finished, look at the" \
	     "results in build/doctest/output.txt"; \
	false; }

pydoc-topics: BUILDER = pydoc-topics
pydoc-topics: build
	@echo "Building finished; now copy build/pydoc-topics/topics.py" \
	      "to ../Lib/pydoc_data/topics.py"

htmlview: html
	 $(PYTHON) -c "import webbrowser; webbrowser.open('build/html/index.html')"

clean:
	-rm -rf build/* $(VENVDIR)/*

venv:
	$(PYTHON) -m venv $(VENVDIR)
	$(VENVDIR)/bin/python3 -m pip install -U Sphinx blurb
	@echo "The venv has been created in the $(VENVDIR) directory"

dist:
	rm -rf dist
	mkdir -p dist

	# archive the HTML
	make html
	cp -pPR build/html dist/python-$(DISTVERSION)-docs-html
	tar -C dist -cf dist/python-$(DISTVERSION)-docs-html.tar python-$(DISTVERSION)-docs-html
	bzip2 -9 -k dist/python-$(DISTVERSION)-docs-html.tar
	(cd dist; zip -q -r -9 python-$(DISTVERSION)-docs-html.zip python-$(DISTVERSION)-docs-html)
	rm -r dist/python-$(DISTVERSION)-docs-html
	rm dist/python-$(DISTVERSION)-docs-html.tar

	# archive the text build
	make text
	cp -pPR build/text dist/python-$(DISTVERSION)-docs-text
	tar -C dist -cf dist/python-$(DISTVERSION)-docs-text.tar python-$(DISTVERSION)-docs-text
	bzip2 -9 -k dist/python-$(DISTVERSION)-docs-text.tar
	(cd dist; zip -q -r -9 python-$(DISTVERSION)-docs-text.zip python-$(DISTVERSION)-docs-text)
	rm -r dist/python-$(DISTVERSION)-docs-text
	rm dist/python-$(DISTVERSION)-docs-text.tar

	# archive the A4 latex
	rm -rf build/latex
	make latex PAPER=a4
	-sed -i 's/makeindex/makeindex -q/' build/latex/Makefile
	(cd build/latex; make clean && make all-pdf && make FMT=pdf zip bz2)
	cp build/latex/docs-pdf.zip dist/python-$(DISTVERSION)-docs-pdf-a4.zip
	cp build/latex/docs-pdf.tar.bz2 dist/python-$(DISTVERSION)-docs-pdf-a4.tar.bz2

	# archive the letter latex
	rm -rf build/latex
	make latex PAPER=letter
	-sed -i 's/makeindex/makeindex -q/' build/latex/Makefile
	(cd build/latex; make clean && make all-pdf && make FMT=pdf zip bz2)
	cp build/latex/docs-pdf.zip dist/python-$(DISTVERSION)-docs-pdf-letter.zip
	cp build/latex/docs-pdf.tar.bz2 dist/python-$(DISTVERSION)-docs-pdf-letter.tar.bz2

	# copy the epub build
	rm -rf build/epub
	make epub
	cp -pPR build/epub/Python.epub dist/python-$(DISTVERSION)-docs.epub

check:
	$(PYTHON)2 tools/rstlint.py -i tools -i $(VENVDIR)

serve:
	../Tools/scripts/serve.py build/html

# Targets for daily automated doc build

# for development releases: always build
autobuild-dev:
	make dist SPHINXOPTS='$(SPHINXOPTS) -A daily=1 -A switchers=1'
	-make suspicious

# for quick rebuilds (HTML only)
autobuild-dev-html:
	make html SPHINXOPTS='$(SPHINXOPTS) -A daily=1 -A switchers=1'

# for stable releases: only build if not in pre-release stage (alpha, beta)
# release candidate downloads are okay, since the stable tree can be in that stage
autobuild-stable:
	@case $(DISTVERSION) in *[ab]*) \
		echo "Not building; $(DISTVERSION) is not a release version."; \
		exit 1;; \
	esac
	@make autobuild-dev

autobuild-stable-html:
	@case $(DISTVERSION) in *[ab]*) \
		echo "Not building; $(DISTVERSION) is not a release version."; \
		exit 1;; \
	esac
	@make autobuild-dev-html

## python2.7 2.7.18.1

=== debian/changelog ===
python2.7 (2.7.18.1-1+deepin) UNRELEASED; urgency=medium

  * update

 -- Matthias Klose <doko@debian.org>  Thu, 28 Jul 2022 13:57:38 +0800

python2.7 (2.7.18.1-1+deepin) unstable; urgency=medium

  * Add sunway support.

 -- Miao Changwei <miaochangwei@uniontech.com>  Thu, 21 Apr 2022 01:45:40 +0800

python2.7 (2.7.18-13.4) unstable; urgency=medium

  * Non-maintainer upload.
  * CVE-2021-4189: make ftplib not trust the PASV response.
  * CVE-2021-23336: only use '&' as a query string separator.

 -- Anton Gladky <gladk@debian.org>  Mon, 28 Mar 2022 22:47:09 +0200

python2.7 (2.7.18-13) unstable; urgency=medium

  * Skip tests requiring TLS 1.2 under OpenSSL 3.
  * Test suite adjustments for Expat >=2.4.5. Closes: #1006240.

 -- Matthias Klose <doko@debian.org>  Tue, 22 Feb 2022 12:45:08 +0100

python2.7 (2.7.18-12) unstable; urgency=medium

  * Apply patches for a binary-indep only build.

 -- Matthias Klose <doko@debian.org>  Sun, 23 Jan 2022 18:03:09 +0100

python2.7 (2.7.18-11) unstable; urgency=medium

  [ Stefano Rivera ]
  * Preliminary OpenSSL 3 support.
  * Support building docs with Sphinx 4.

  [ Matthias Klose ]
  * (Build-)Depend on media-types. Closes: #991565.
  * Bump standards version.
  * Bump debhelper version.

 -- Matthias Klose <doko@debian.org>  Fri, 21 Jan 2022 15:07:38 +0100

python2.7 (2.7.18-9) unstable; urgency=medium

  * Bump standards version.

 -- Matthias Klose <doko@debian.org>  Fri, 24 Sep 2021 11:39:51 +0200

python2.7 (2.7.18-8) unstable; urgency=medium

  [ Andreas Beckmann ]
  * python2.7, libpython2.7-minimal: Add Breaks: python-dev (<< 2.7.18),
    libpython-dev (<< 2.7.18), python-dbg (<< 2.7.18),
    libpython-dbg (<< 2.7.18) to remove more unversioned python packages.
    Add Breaks: libgcj-common (<< 1:7), libvolk1-bin (<< 2),
    pysycache (<< 3.1-4~), python-catkin-pkg (<< 0.4.14-2~),
    python-chardet (<< 3.0.4-6~), python-extras (<< 1.0.0-4~),
    python-fixtures (<< 3.0.0-3~), python-genpy (<< 0.6.9-2~),
    python-iso8601 (<< 0.1.12-2~), python-linecache2 (<< 1.0.0-4~),
    python-pbr (<< 5.4.5), python-pyasn1 (<< 0.4.2-4~),
    python-pygame (<< 1.9.6+dfsg-3~), python-pyicu (<< 2.2-3~),
    python-rospkg (1.1.10-2~), python-std-msgs (<< 0.5.12-2~),
    python-testtools (<< 2.3.0-7~), python-traceback2 (<< 1.4.0-6~),
    python-traitlets (<< 4.3.3-3~), python-urllib3 (<< 1.25.8-2~),
    python-yaml (<< 5.3.1-2~) to remove some persisting obsolete module
    packages along the unversioned python packages on upgrades from buster.
    Closes: #990520.
  * libpython2.7-stdlib: Breaks: ${python27:Breaks}, too.

 -- Matthias Klose <doko@debian.org>  Wed, 14 Jul 2021 10:11:37 +0200

python2.7 (2.7.18-7) unstable; urgency=medium

  [ Andreas Beckmann ]
  * python2.7, libpython2.7-minimal: Add Breaks: python (<< 2.7.18) to ensure
    removal of the unversioned python packages on upgrades from buster. The
    previously added (transitive) Breaks are not sufficient in a few upgrade
    scenarios. Closes: #987661.

 -- Matthias Klose <doko@debian.org>  Wed, 28 Apr 2021 19:39:59 +0200

python2.7 (2.7.18-6) unstable; urgency=medium

  * python2.7, libpython2.7-minimal: Add Breaks: python-minimal (<< 2.7.18),
    libpython-stdlib (<< 2.7.18) to ensure removal of the unversioned python
    packages on upgrades from buster (Andreas Beckmann). Closes: #984777.

 -- Matthias Klose <doko@debian.org>  Tue, 09 Mar 2021 21:20:32 +0100

python2.7 (2.7.18-5) unstable; urgency=medium

  * Use the posix_prefix layout when inside a virtualenv (Stefano Rivera).
    Closes: #983552.

 -- Matthias Klose <doko@debian.org>  Sat, 27 Feb 2021 09:40:44 +0100

python2.7 (2.7.18-4) unstable; urgency=medium

  * Update the patch for issue #42938 (Marc Deslauriers). Closes: #983516.

 -- Matthias Klose <doko@debian.org>  Fri, 26 Feb 2021 07:17:59 +0100

python2.7 (2.7.18-2) unstable; urgency=medium

  * Fix issue #39017: Avoid infinite loop when reading specially crafted TAR
    files using the tarfile module (CVE-2019-20907).
  * Backport of 0b297d4ff1c0e4480ad33acae793fbaf4bf015b4, trimmed down to the
    fix for CVE-2020-8492. Closes: #970099.
  * Fix FTCBFS: Add back a dependency on python2.7:any (Helmut Grohne).
    Closes: #939514.
  * Fix issue #42938: Replace snprintf with Python unicode formatting in
    ctypes param reprs (CVE-2021-3177) (Saif Hakim). LP: #1916117.

 -- Matthias Klose <doko@debian.org>  Sat, 20 Feb 2021 18:14:40 +0100

python2.7 (2.7.18-1) unstable; urgency=medium

  * Python 2.7.18 release.
  * Let the Python2 end-of-life banner point to the python3 packages, not to
    the online documentation.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 20 Apr 2020 22:30:41 +0200

python2.7 (2.7.18~rc1-2) unstable; urgency=medium

  * Ignore some autopkg tests:
    - test_ssl: Fails with OPENSSL_TLS_SECURITY_LEVEL=2.
    - tst_io: Fails on Ubuntu's autopkg test infrastructure.
  * Lower OpenSSL security level from 2 to 1 during testing as test_ssl
    assumes that.
  * Add XB-Cnf-Visible-Pkgname header on the python*-minimal package to
    point command-not-found at the full one. LP: #1867157

 -- Matthias Klose <doko@debian.org>  Tue, 07 Apr 2020 14:05:55 +0200

python2.7 (2.7.18~rc1-1) unstable; urgency=medium

  * Python 2.7.18 release candidate 1.
    - bpo-38576: Disallow control characters in hostnames in http.client,
      addressing CVE-2019-18348.
  * Make autopkgtests cross-test-friendly (Steve Langasek).

 -- Matthias Klose <doko@debian.org>  Tue, 07 Apr 2020 11:34:05 +0200

python2.7 (2.7.17-1) unstable; urgency=medium

  * Python 2.7.17 release.

 -- Matthias Klose <doko@debian.org>  Sun, 20 Oct 2019 01:36:22 +0200

python2.7 (2.7.17~rc1-1) unstable; urgency=medium

  * Python 2.7.17 release candidate 1.
    - CVE-2019-16056, don't parse domains containing @. Closes: #940901.
  * Bump standards version.

 -- Matthias Klose <doko@debian.org>  Thu, 10 Oct 2019 12:26:01 +0200

python2.7 (2.7.16-4) unstable; urgency=medium



=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: python
 Priority: optional
 Maintainer: Matthias Klose <doko@debian.org>
-Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.17.11), 
+Build-Depends: debhelper (>= 11), dpkg-dev (>= 1.17.11), 
   quilt, autoconf, autotools-dev,
   lsb-release, sharutils,
   libreadline-dev, libtinfo-dev, libncursesw5-dev (>= 5.3),
@@ -13,15 +13,15 @@
   locales [!armel !avr32 !hppa !ia64 !mipsel],
   libsqlite3-dev, libffi-dev (>= 3.0.5) [!or1k !avr32],
   libgpm2 [linux-any],
-  mime-support, netbase, net-tools, bzip2, time,
-  libdb-dev (<< 1:6.0), libgdbm-dev, python:any, help2man,
-  xvfb, xauth
+  media-types | mime-support, netbase, net-tools, bzip2, time,
+  libdb-dev (<< 1:6.0), libgdbm-dev, help2man,
+  xvfb <!nocheck>, xauth <!nocheck>, python2.7:any <cross>
 Build-Depends-Indep: python3-sphinx
 Build-Conflicts: tcl8.4-dev, tk8.4-dev,
   python2.7-xml, python-xml,
   autoconf2.13, python-cxx-dev,
   hardening-wrapper
-Standards-Version: 4.3.0
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/cpython-team/python2
 Vcs-Git: https://salsa.debian.org/cpython-team/python2.git
 XS-Testsuite: autopkgtest
@@ -30,10 +30,10 @@
 Architecture: any
 Multi-Arch: allowed
 Priority: optional
-Depends: python2.7-minimal (= ${binary:Version}), libpython2.7-stdlib (= ${binary:Version}), mime-support, ${shlibs:Depends}, ${misc:Depends}
+Depends: python2.7-minimal (= ${binary:Version}), libpython2.7-stdlib (= ${binary:Version}), media-types | mime-support, ${shlibs:Depends}, ${misc:Depends}
 Suggests: python2.7-doc, binutils
 Conflicts: python-profiler (<= 2.7.1-2)
-Breaks: python-virtualenv (<< 1.7.1.2-2~), vim-nox (<< 2:7.3.547-4), vim-gtk (<< 2:7.3.547-4), vim-gnome (<< 2:7.3.547-4), vim-athena (<< 2:7.3.547-4)
+Breaks: python-virtualenv (<< 1.7.1.2-2~), vim-nox (<< 2:7.3.547-4), vim-gtk (<< 2:7.3.547-4), vim-gnome (<< 2:7.3.547-4), vim-athena (<< 2:7.3.547-4), ${python27:Breaks}
 Replaces: python-profiler (<= 2.7.1-2), python2.7-minimal (<< 2.7.3-7~)
 Description: Interactive high-level object-oriented language (version 2.7)
  Python is a high-level, interactive, object-oriented language. Its 2.7 version
@@ -44,10 +44,10 @@
 Architecture: any
 Multi-Arch: same
 Priority: optional
-Depends: libpython2.7-minimal (= ${binary:Version}), libssl1.1 (>= 1.1.1), mime-support, ${shlibs:Depends}, ${misc:Depends}
+Depends: libpython2.7-minimal (= ${binary:Version}), libssl3, media-types | mime-support, ${shlibs:Depends}, ${misc:Depends}
 Provides: python2.7-cjkcodecs, python2.7-ctypes, python2.7-elementtree, python2.7-celementtree, python2.7-wsgiref, python2.7-profiler, python2.7-argparse, python-argparse
 Replaces: python2.7 (<< 2.7.5-0~), libpython2.7-testsuite (<< 2.7.13-4)
-Breaks: python-urllib3 (<< 1.9.1-3), ${pyfpe:Breaks}
+Breaks: python-urllib3 (<< 1.9.1-3), ${pyfpe:Breaks}, ${python27:Breaks}
 Description: Interactive high-level object-oriented language (standard library, version 2.7)
  Python is a high-level, interactive, object-oriented language. Its 2.7 version
  includes an extensive class library with lots of goodies for
@@ -66,11 +66,13 @@
 Suggests: binfmt-support
 Replaces: python2.7 (<< 2.7.8-7~)
 Conflicts: binfmt-support (<< 1.1.2)
+Breaks: ${python27:Breaks}
 Description: Minimal subset of the Python language (version 2.7)
  This package contains the interpreter and some essential modules.  It can
  be used in the boot process for some basic tasks.
  See /usr/share/doc/python2.7-minimal/README.Debian for a list of the modules
  contained in this package.
+XB-Cnf-Visible-Pkgname: python2.7
 
 Package: libpython2.7-minimal
 Architecture: any
@@ -79,7 +81,7 @@
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Recommends: libpython2.7-stdlib
 Replaces: python2.7 (<< 2.7.4-2), python2.7-minimal (<< 2.7.3-10), libpython2.7-stdlib (<< 2.7.8-7)
-Breaks: python2.7-minimal (<< 2.7.4~rc1-1~)
+Breaks: python2.7-minimal (<< 2.7.4~rc1-1~), ${python27:Breaks}
 Conflicts: binfmt-support (<< 1.1.2)
 Description: Minimal subset of the Python language (version 2.7)
  This package contains some essential modules. It is normally not

=== debian/rules ===
--- 
+++ 
@@ -4,6 +4,8 @@
 unexport CFLAGS CXXFLAGS CPPFLAGS LDFLAGS
 
 export SHELL = /bin/bash
+
+export OPENSSL_CONF = $(CURDIR)/debian/openssl.cnf
 
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
@@ -48,7 +50,7 @@
   WITHOUT_BENCH := disabled on $(DEB_HOST_ARCH)
 endif
 ifeq ($(on_buildd),yes)
-  ifneq (,$(findstring $(DEB_HOST_ARCH), hppa loongarch64 mips mipsel mipsn32 mipsn32el mips64 mips64el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64r6 mips64r6el s390))
+  ifneq (,$(findstring $(DEB_HOST_ARCH), hppa mips mipsel mipsn32 mipsn32el mips64 mips64el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64r6 mips64r6el s390))
     WITHOUT_CHECK := yes
   endif
 endif
@@ -158,10 +160,6 @@
     DEBUG_CFLAGS += -mieee
     EXTRA_OPT_FLAGS += -O2
 endif
-# on sw_64, use -O0
-ifeq ($(DEB_HOST_ARCH),sw_64)
-    OPT_CFLAGS += -O0
-endif
 # issues with ia64 and m68k with -O3
 ifeq ($(DEB_HOST_ARCH),m68k)
     EXTRA_OPT_FLAGS += -O2
@@ -172,8 +170,13 @@
     DEBUG_CFLAGS += -fexceptions
 endif
 
+# on sunway, use -O2 only, use -mieee
+ifneq (,$(filter $(DEB_HOST_ARCH), sw64))
+    EXTRA_OPT_FLAGS += -O2
+endif
+
 ifeq ($(DEB_HOST_ARCH_OS),linux)
-  ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 armel armhf i386 powerpc ppc64 ppc64el s390x x32 sw_64))
+  ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 armel armhf i386 powerpc ppc64 ppc64el s390x x32))
     with_pgo := yes
   endif
 endif
@@ -181,7 +184,7 @@
   with_pgo :=
 endif
 
-ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 armel armhf i386 powerpc ppc64 ppc64el s390x x32 sw_64))
+ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 armel armhf i386 powerpc ppc64 ppc64el s390x x32))
   with_lto := yes
 endif
 
@@ -207,6 +210,14 @@
 
 make_build_target = $(if $(with_pgo),profile-opt)
 
+ifeq ($(derivative),Ubuntu)
+  arch_substvars =
+else ifeq ($(derivative),Debian)
+    ifneq (,$(filter $(distrelease), sid bullseye))
+      arch_substvars = '-Vpython27:Breaks=$(shell tr '\n' ' ' < debian/py27-breaks.$(derivative))'
+    endif
+endif
+
 buildd_static	:= $(CURDIR)/build-static
 buildd_shared	:= $(CURDIR)/build-shared
 buildd_debug	:= $(CURDIR)/build-debug
@@ -224,17 +235,3 @@
 p_tk	:= $(PVER)-tk
 p_gdbm	:= $(PVER)-gdbm
 p_dev	:= $(PVER)-dev
-p_exam	:= $(PVER)-examples
-p_idle	:= idle-$(PVER)
-p_doc	:= $(PVER)-doc
-p_dbg	:= $(PVER)-dbg
-
-p_lbase	:= lib$(PVER)-stdlib
-p_lmin	:= lib$(PVER)-minimal
-p_ldev	:= lib$(PVER)-dev
-p_ldbg	:= lib$(PVER)-dbg
-p_ltst	:= lib$(PVER)-testsuite
-
-d_base	:= debian/$(p_base)
-d_min	:= debian/$(p_min)
-d_lib	:= debian/$(p_lib)

=== debian/tests/control ===
Tests: testsuite
Depends: build-essential, locales:native, python2.7-dev, libpython2.7-testsuite:native, python-gdbm
# test_zipfile wants to write
Restrictions: needs-root

Tests: testsuite-dbg
Depends: build-essential, locales:native, python2.7-dev, python2.7-dbg, libpython2.7-testsuite:native, python-gdbm-dbg
# test_zipfile wants to write
Restrictions: needs-root

Tests: failing-tests
Depends: build-essential, locales:native, python2.7-dev, libpython2.7-testsuite:native, python-gdbm
# test_zipfile wants to write
Restrictions: needs-root allow-stderr

Tests: failing-tests-dbg
Depends: build-essential, locales:native, python2.7-dev, python2.7-dbg, libpython2.7-testsuite:native, python-gdbm-dbg
# test_zipfile wants to write
Restrictions: needs-root allow-stderr
